#ifdef  HAVE_CONFIG_H
# include <config.h>
#endif/*HAVE_CONFIG_H*/

#include <string.h>

#include <conf.h>
#include <socket.h>
#include <network.h>
#include <array.h>
#include <joedog/joedog.h>
#include <joedog/boolean.h>
#include <joedog/defs.h>

void
portspin(BOOLEAN found, char *host, int port)
{
  char h[4] = {'-','\\','|','/'};
  size_t len;
  int i;

  fflush(stdout);
  usleep(9000);
  if(found){
    fprintf(stdout,"%s:%d\n", host, port);
  } else {
    len = strlen(host)+5;
    fprintf(stdout,"%s:%c", host, h[port%4]);
    for(i = 0; i < (int)len; i++)
      fprintf(stdout, "\b");
  }
  return;
}

BOOLEAN 
netping(SOCKET S){
  BOOLEAN found = socket_check(S);
  if(found){
    fflush(stdout);
    fprintf(stdout,"==> %s\n", socket_get_ptr(S));
    return found;
  } else {
    return FALSE;
  }
}

BOOLEAN
netspin(SOCKET S){
  int i;
  size_t len = 0;
  char h[4]  = {'-','\\','|','/'};
  BOOLEAN found = socket_check(S);

  fflush(stdout);
  usleep(9000);
  if(found){
    fflush(stdout);
    fprintf(stdout,"==> %s\n", socket_get_ptr(S));
    return found;
  } else {
    len = strlen(socket_get_hostname(S))+5;
    fprintf(stdout,"%s:%c", socket_get_hostname(S), h[socket_get_port(S)%4]);
    for(i = 0; i < (int)len; i++)
      fprintf(stdout, "\b");
  }
  return FALSE;
}

BOOLEAN 
portscan(CONF C){
  int i;
  size_t len = strlen(get_address(C))+5;
  SOCKET  S  = new_socket(get_address(C), 1, get_protocol(C));

  socket_set_debug(S, get_debug(C));
  socket_set_timeout(S, get_timeout(C));
  for(i = get_lower(C); i < get_upper(C)+1; i++){
    socket_set_port(S, i);
    portspin(socket_check(S), get_address(C), i);
  }
  fflush(stdout);
  for(i = 0; i < (int)len; i++)
    fprintf(stdout, "\b");
  for(i = 0; i < (int)len; i++)
    fprintf(stdout, "\b");
  fprintf(stdout, "[done]");
  for(i = 0; i < (int)len; i++)
    fprintf(stdout, " ");
  fprintf(stdout, "\n");
  S = socket_destroy(S);  
  return TRUE;
}

BOOLEAN 
netscan(CONF C){
  int p, x, ux, y = 0;
  ARRAY   A = get_ports(C);

  NETWORK N = new_network(get_address(C));  
  if(N == NULL){
    return FALSE;
  }

  if(network_get_octet(N, THIRD)==0){
    x  = 0;
    ux = 255;
  } else {
    x  = network_get_octet(N, THIRD);
    ux = x+1;
  }

  for( ; x < ux; x++){
    for(y = 0; y < 256; y++){
      SOCKET S;
      int i;
      size_t len = 32;
      char addr[256];
      snprintf(
        addr, 256,
        "%d.%d.%d.%d", 
        network_get_octet(N, FIRST), 
        network_get_octet(N, SECOND), 
        x, y
      );
      S  = new_socket(addr, 1, get_protocol(C));
      socket_set_debug(S, get_debug(C));
      socket_set_timeout(S, get_timeout(C));
      if(get_protocol(C)==ICMP){
        netping(S);
      } else {
        /* Loop through ports */
        for(p = 0; p < (int)array_get_size(A); p++){
          socket_set_port(S, (int)array_get(A, p));
          if(netspin(S)==TRUE){ 
            break;
          }
        }
      }
      fflush(stdout);
      for(i = 0; i < (int)len; i++)
        fprintf(stdout, "\b");
      for(i = 0; i < (int)len; i++)
        fprintf(stdout, "\b");
      S = socket_destroy(S);  
    }
  }
  
  return TRUE;
}


